package cn.ibizlab.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.sample.domain.IBIZAPPEDITOR;
import cn.ibizlab.core.sample.filter.IBIZAPPEDITORSearchContext;
import cn.ibizlab.core.sample.service.IIBIZAPPEDITORService;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;
import com.alibaba.fastjson.JSONObject;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.sample.mapper.IBIZAPPEDITORMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import org.springframework.util.StringUtils;

/**
 * 实体[编辑器] 服务对象接口实现
 */
@Slf4j
@Service("IBIZAPPEDITORServiceImpl")
public class IBIZAPPEDITORServiceImpl extends ServiceImpl<IBIZAPPEDITORMapper, IBIZAPPEDITOR> implements IIBIZAPPEDITORService {


    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(IBIZAPPEDITOR et) {
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizappeditorid()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<IBIZAPPEDITOR> list) {
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBIZAPPEDITOR et) {
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("ibizappeditorid", et.getIbizappeditorid()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizappeditorid()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<IBIZAPPEDITOR> list) {
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public IBIZAPPEDITOR get(String key) {
        IBIZAPPEDITOR et = getById(key);
        if (et == null) {
            throw new BadRequestAlertException("数据不存在", this.getClass().getSimpleName(), key);
        }
        else {
        }
        return et;
    }

    @Override
    public IBIZAPPEDITOR getDraft(IBIZAPPEDITOR et) {
        return et;
    }

    @Override
    public boolean checkKey(IBIZAPPEDITOR et) {
        return (!ObjectUtils.isEmpty(et.getIbizappeditorid())) && (!Objects.isNull(this.getById(et.getIbizappeditorid())));
    }
    @Override
    @Transactional
    public boolean save(IBIZAPPEDITOR et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(IBIZAPPEDITOR et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? getProxyService().update(et) : getProxyService().create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<IBIZAPPEDITOR> list) {
        List<IBIZAPPEDITOR> create = new ArrayList<>();
        List<IBIZAPPEDITOR> update = new ArrayList<>();
        for (IBIZAPPEDITOR et : list) {
            if (ObjectUtils.isEmpty(et.getIbizappeditorid()) || ObjectUtils.isEmpty(getById(et.getIbizappeditorid()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<IBIZAPPEDITOR> list) {
        List<IBIZAPPEDITOR> create = new ArrayList<>();
        List<IBIZAPPEDITOR> update = new ArrayList<>();
        for (IBIZAPPEDITOR et : list) {
            if (ObjectUtils.isEmpty(et.getIbizappeditorid()) || ObjectUtils.isEmpty(getById(et.getIbizappeditorid()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
    }



    /**
     * 查询集合 数据集
     */
    @Override
    public Page<IBIZAPPEDITOR> searchDefault(IBIZAPPEDITORSearchContext context) {
            com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZAPPEDITOR> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
            return new PageImpl<IBIZAPPEDITOR>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<IBIZAPPEDITOR> getIbizappeditorByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<IBIZAPPEDITOR> getIbizappeditorByEntities(List<IBIZAPPEDITOR> entities) {
        List ids =new ArrayList();
        for(IBIZAPPEDITOR entity : entities){
            Serializable id=entity.getIbizappeditorid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0) {
            return this.listByIds(ids);
        }
        else {
            return entities;
        }
    }




    public IIBIZAPPEDITORService getProxyService() {
        return cn.ibizlab.util.security.SpringContextHolder.getBean(this.getClass());
    }
}



